// Copyright 2022 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package api

// GENERATED BY go run ./tools/cmd/gen-types. DO NOT EDIT.

//lint:file-ignore S1001,S1002,S1008,SA4013 generated code

import (
	"bytes"
	"encoding/json"
	"errors"
	"fmt"
	"io"
	"strings"
	"time"

	"gitlab.com/accumulatenetwork/accumulate/pkg/types/encoding"
	"gitlab.com/accumulatenetwork/accumulate/pkg/url"
	"gitlab.com/accumulatenetwork/accumulate/protocol"
)

type Adi struct {
	fieldsSet []bool
	Url       *url.URL `json:"url,omitempty" form:"url" query:"url" validate:"required"`
	Pages     []Page   `json:"pages,omitempty" form:"pages" query:"pages"`
	extraData []byte
}

type DerivationCount struct {
	WalletId *url.URL               `json:"walletId,omitempty" form:"walletId" query:"walletId"`
	Type     protocol.SignatureType `json:"type,omitempty" form:"type" query:"type" validate:"required"`
	Count    uint64                 `json:"count,omitempty" form:"count" query:"count" validate:"required"`
}

type Key struct {
	PrivateKey []byte     `json:"privateKey,omitempty" form:"privateKey" query:"privateKey"`
	PublicKey  []byte     `json:"publicKey,omitempty" form:"publicKey" query:"publicKey" validate:"required"`
	KeyInfo    KeyInfo    `json:"keyInfo,omitempty" form:"keyInfo" query:"keyInfo" validate:"required"`
	LastUsedOn uint64     `json:"lastUsedOn,omitempty" form:"lastUsedOn" query:"lastUsedOn" validate:"required"`
	Labels     *KeyLabels `json:"labels,omitempty" form:"labels" query:"labels"`
	Pages      []*url.URL `json:"pages,omitempty" form:"pages" query:"pages" validate:"required"`
}

type KeyInfo struct {
	fieldsSet  []bool
	Type       protocol.SignatureType `json:"type,omitempty" form:"type" query:"type" validate:"required"`
	Derivation string                 `json:"derivation,omitempty" form:"derivation" query:"derivation"`
	WalletId   *url.URL               `json:"walletId,omitempty" form:"walletId" query:"walletId"`
	extraData  []byte
}

type KeyLabels struct {
	fieldsSet []bool
	Lite      string   `json:"lite,omitempty" form:"lite" query:"lite" validate:"required"`
	Hash      []byte   `json:"hash,omitempty" form:"hash" query:"hash" validate:"required"`
	Names     []string `json:"names,omitempty" form:"names" query:"names" validate:"required"`
	extraData []byte
}

type KeyName struct {
	fieldsSet []bool
	Name      string `json:"name,omitempty" form:"name" query:"name" validate:"required"`
	PublicKey []byte `json:"publicKey,omitempty" form:"publicKey" query:"publicKey" validate:"required"`
	extraData []byte
}

type LiteLabel struct {
	LiteName string `json:"liteName,omitempty" form:"liteName" query:"liteName" validate:"required"`
	KeyName  string `json:"keyName,omitempty" form:"keyName" query:"keyName" validate:"required"`
}

type Page struct {
	fieldsSet []bool
	Url       *url.URL `json:"url,omitempty" form:"url" query:"url" validate:"required"`
	KeyNames  []string `json:"keyNames,omitempty" form:"keyNames" query:"keyNames" validate:"required"`
	extraData []byte
}

type SeedInfo struct {
	Mnemonic string `json:"mnemonic,omitempty" form:"mnemonic" query:"mnemonic" validate:"required"`
	Seed     []byte `json:"seed,omitempty" form:"seed" query:"seed" validate:"required"`
}

type Vault struct {
	BackupDate         time.Time         `json:"backupDate,omitempty" form:"backupDate" query:"backupDate" validate:"required"`
	Version            Version           `json:"version,omitempty" form:"version" query:"version" validate:"required"`
	SeedInfo           SeedInfo          `json:"seedInfo,omitempty" form:"seedInfo" query:"seedInfo" validate:"required"`
	DerivationCounters []DerivationCount `json:"derivationCounters,omitempty" form:"derivationCounters" query:"derivationCounters" validate:"required"`
	Keys               []Key             `json:"keys,omitempty" form:"keys" query:"keys" validate:"required"`
	KeyNames           []KeyName         `json:"keyNames,omitempty" form:"keyNames" query:"keyNames" validate:"required"`
	LiteLabels         []LiteLabel       `json:"liteLabels,omitempty" form:"liteLabels" query:"liteLabels" validate:"required"`
	Adis               []Adi             `json:"adis,omitempty" form:"adis" query:"adis"`
}

type VaultInfo struct {
	fieldsSet      []bool
	Name           string `json:"name,omitempty" form:"name" query:"name"`
	FilePath       string `json:"filePath,omitempty" form:"filePath" query:"filePath"`
	OnePasswordRef string `json:"onePasswordRef,omitempty" form:"onePasswordRef" query:"onePasswordRef"`
	extraData      []byte
}

type VaultList struct {
	fieldsSet []bool
	Vaults    []string `json:"vaults,omitempty" form:"vaults" query:"vaults" validate:"required"`
	extraData []byte
}

type Version struct {
	Major    uint64 `json:"major,omitempty" form:"major" query:"major" validate:"required"`
	Minor    uint64 `json:"minor,omitempty" form:"minor" query:"minor" validate:"required"`
	Revision uint64 `json:"revision,omitempty" form:"revision" query:"revision" validate:"required"`
	Commit   uint64 `json:"commit,omitempty" form:"commit" query:"commit" validate:"required"`
}

func (v *Adi) Copy() *Adi {
	u := new(Adi)

	if v.Url != nil {
		u.Url = v.Url
	}
	u.Pages = make([]Page, len(v.Pages))
	for i, v := range v.Pages {
		v := v
		u.Pages[i] = *(&v).Copy()
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Adi) CopyAsInterface() interface{} { return v.Copy() }

func (v *DerivationCount) Copy() *DerivationCount {
	u := new(DerivationCount)

	if v.WalletId != nil {
		u.WalletId = v.WalletId
	}
	u.Type = v.Type
	u.Count = v.Count

	return u
}

func (v *DerivationCount) CopyAsInterface() interface{} { return v.Copy() }

func (v *Key) Copy() *Key {
	u := new(Key)

	u.PrivateKey = encoding.BytesCopy(v.PrivateKey)
	u.PublicKey = encoding.BytesCopy(v.PublicKey)
	u.KeyInfo = *(&v.KeyInfo).Copy()
	u.LastUsedOn = v.LastUsedOn
	if v.Labels != nil {
		u.Labels = (v.Labels).Copy()
	}
	u.Pages = make([]*url.URL, len(v.Pages))
	for i, v := range v.Pages {
		v := v
		if v != nil {
			u.Pages[i] = v
		}
	}

	return u
}

func (v *Key) CopyAsInterface() interface{} { return v.Copy() }

func (v *KeyInfo) Copy() *KeyInfo {
	u := new(KeyInfo)

	u.Type = v.Type
	u.Derivation = v.Derivation
	if v.WalletId != nil {
		u.WalletId = v.WalletId
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *KeyInfo) CopyAsInterface() interface{} { return v.Copy() }

func (v *KeyLabels) Copy() *KeyLabels {
	u := new(KeyLabels)

	u.Lite = v.Lite
	u.Hash = encoding.BytesCopy(v.Hash)
	u.Names = make([]string, len(v.Names))
	for i, v := range v.Names {
		v := v
		u.Names[i] = v
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *KeyLabels) CopyAsInterface() interface{} { return v.Copy() }

func (v *KeyName) Copy() *KeyName {
	u := new(KeyName)

	u.Name = v.Name
	u.PublicKey = encoding.BytesCopy(v.PublicKey)
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *KeyName) CopyAsInterface() interface{} { return v.Copy() }

func (v *LiteLabel) Copy() *LiteLabel {
	u := new(LiteLabel)

	u.LiteName = v.LiteName
	u.KeyName = v.KeyName

	return u
}

func (v *LiteLabel) CopyAsInterface() interface{} { return v.Copy() }

func (v *Page) Copy() *Page {
	u := new(Page)

	if v.Url != nil {
		u.Url = v.Url
	}
	u.KeyNames = make([]string, len(v.KeyNames))
	for i, v := range v.KeyNames {
		v := v
		u.KeyNames[i] = v
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Page) CopyAsInterface() interface{} { return v.Copy() }

func (v *SeedInfo) Copy() *SeedInfo {
	u := new(SeedInfo)

	u.Mnemonic = v.Mnemonic
	u.Seed = encoding.BytesCopy(v.Seed)

	return u
}

func (v *SeedInfo) CopyAsInterface() interface{} { return v.Copy() }

func (v *Vault) Copy() *Vault {
	u := new(Vault)

	u.BackupDate = v.BackupDate
	u.Version = *(&v.Version).Copy()
	u.SeedInfo = *(&v.SeedInfo).Copy()
	u.DerivationCounters = make([]DerivationCount, len(v.DerivationCounters))
	for i, v := range v.DerivationCounters {
		v := v
		u.DerivationCounters[i] = *(&v).Copy()
	}
	u.Keys = make([]Key, len(v.Keys))
	for i, v := range v.Keys {
		v := v
		u.Keys[i] = *(&v).Copy()
	}
	u.KeyNames = make([]KeyName, len(v.KeyNames))
	for i, v := range v.KeyNames {
		v := v
		u.KeyNames[i] = *(&v).Copy()
	}
	u.LiteLabels = make([]LiteLabel, len(v.LiteLabels))
	for i, v := range v.LiteLabels {
		v := v
		u.LiteLabels[i] = *(&v).Copy()
	}
	u.Adis = make([]Adi, len(v.Adis))
	for i, v := range v.Adis {
		v := v
		u.Adis[i] = *(&v).Copy()
	}

	return u
}

func (v *Vault) CopyAsInterface() interface{} { return v.Copy() }

func (v *VaultInfo) Copy() *VaultInfo {
	u := new(VaultInfo)

	u.Name = v.Name
	u.FilePath = v.FilePath
	u.OnePasswordRef = v.OnePasswordRef
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *VaultInfo) CopyAsInterface() interface{} { return v.Copy() }

func (v *VaultList) Copy() *VaultList {
	u := new(VaultList)

	u.Vaults = make([]string, len(v.Vaults))
	for i, v := range v.Vaults {
		v := v
		u.Vaults[i] = v
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *VaultList) CopyAsInterface() interface{} { return v.Copy() }

func (v *Version) Copy() *Version {
	u := new(Version)

	u.Major = v.Major
	u.Minor = v.Minor
	u.Revision = v.Revision
	u.Commit = v.Commit

	return u
}

func (v *Version) CopyAsInterface() interface{} { return v.Copy() }

func (v *Adi) Equal(u *Adi) bool {
	switch {
	case v.Url == u.Url:
		// equal
	case v.Url == nil || u.Url == nil:
		return false
	case !((v.Url).Equal(u.Url)):
		return false
	}
	if len(v.Pages) != len(u.Pages) {
		return false
	}
	for i := range v.Pages {
		if !((&v.Pages[i]).Equal(&u.Pages[i])) {
			return false
		}
	}

	return true
}

func (v *DerivationCount) Equal(u *DerivationCount) bool {
	switch {
	case v.WalletId == u.WalletId:
		// equal
	case v.WalletId == nil || u.WalletId == nil:
		return false
	case !((v.WalletId).Equal(u.WalletId)):
		return false
	}
	if !(v.Type == u.Type) {
		return false
	}
	if !(v.Count == u.Count) {
		return false
	}

	return true
}

func (v *Key) Equal(u *Key) bool {
	if !(bytes.Equal(v.PrivateKey, u.PrivateKey)) {
		return false
	}
	if !(bytes.Equal(v.PublicKey, u.PublicKey)) {
		return false
	}
	if !((&v.KeyInfo).Equal(&u.KeyInfo)) {
		return false
	}
	if !(v.LastUsedOn == u.LastUsedOn) {
		return false
	}
	switch {
	case v.Labels == u.Labels:
		// equal
	case v.Labels == nil || u.Labels == nil:
		return false
	case !((v.Labels).Equal(u.Labels)):
		return false
	}
	if len(v.Pages) != len(u.Pages) {
		return false
	}
	for i := range v.Pages {
		if !((v.Pages[i]).Equal(u.Pages[i])) {
			return false
		}
	}

	return true
}

func (v *KeyInfo) Equal(u *KeyInfo) bool {
	if !(v.Type == u.Type) {
		return false
	}
	if !(v.Derivation == u.Derivation) {
		return false
	}
	switch {
	case v.WalletId == u.WalletId:
		// equal
	case v.WalletId == nil || u.WalletId == nil:
		return false
	case !((v.WalletId).Equal(u.WalletId)):
		return false
	}

	return true
}

func (v *KeyLabels) Equal(u *KeyLabels) bool {
	if !(v.Lite == u.Lite) {
		return false
	}
	if !(bytes.Equal(v.Hash, u.Hash)) {
		return false
	}
	if len(v.Names) != len(u.Names) {
		return false
	}
	for i := range v.Names {
		if !(v.Names[i] == u.Names[i]) {
			return false
		}
	}

	return true
}

func (v *KeyName) Equal(u *KeyName) bool {
	if !(v.Name == u.Name) {
		return false
	}
	if !(bytes.Equal(v.PublicKey, u.PublicKey)) {
		return false
	}

	return true
}

func (v *LiteLabel) Equal(u *LiteLabel) bool {
	if !(v.LiteName == u.LiteName) {
		return false
	}
	if !(v.KeyName == u.KeyName) {
		return false
	}

	return true
}

func (v *Page) Equal(u *Page) bool {
	switch {
	case v.Url == u.Url:
		// equal
	case v.Url == nil || u.Url == nil:
		return false
	case !((v.Url).Equal(u.Url)):
		return false
	}
	if len(v.KeyNames) != len(u.KeyNames) {
		return false
	}
	for i := range v.KeyNames {
		if !(v.KeyNames[i] == u.KeyNames[i]) {
			return false
		}
	}

	return true
}

func (v *SeedInfo) Equal(u *SeedInfo) bool {
	if !(v.Mnemonic == u.Mnemonic) {
		return false
	}
	if !(bytes.Equal(v.Seed, u.Seed)) {
		return false
	}

	return true
}

func (v *Vault) Equal(u *Vault) bool {
	if !((v.BackupDate).Equal(u.BackupDate)) {
		return false
	}
	if !((&v.Version).Equal(&u.Version)) {
		return false
	}
	if !((&v.SeedInfo).Equal(&u.SeedInfo)) {
		return false
	}
	if len(v.DerivationCounters) != len(u.DerivationCounters) {
		return false
	}
	for i := range v.DerivationCounters {
		if !((&v.DerivationCounters[i]).Equal(&u.DerivationCounters[i])) {
			return false
		}
	}
	if len(v.Keys) != len(u.Keys) {
		return false
	}
	for i := range v.Keys {
		if !((&v.Keys[i]).Equal(&u.Keys[i])) {
			return false
		}
	}
	if len(v.KeyNames) != len(u.KeyNames) {
		return false
	}
	for i := range v.KeyNames {
		if !((&v.KeyNames[i]).Equal(&u.KeyNames[i])) {
			return false
		}
	}
	if len(v.LiteLabels) != len(u.LiteLabels) {
		return false
	}
	for i := range v.LiteLabels {
		if !((&v.LiteLabels[i]).Equal(&u.LiteLabels[i])) {
			return false
		}
	}
	if len(v.Adis) != len(u.Adis) {
		return false
	}
	for i := range v.Adis {
		if !((&v.Adis[i]).Equal(&u.Adis[i])) {
			return false
		}
	}

	return true
}

func (v *VaultInfo) Equal(u *VaultInfo) bool {
	if !(v.Name == u.Name) {
		return false
	}
	if !(v.FilePath == u.FilePath) {
		return false
	}
	if !(v.OnePasswordRef == u.OnePasswordRef) {
		return false
	}

	return true
}

func (v *VaultList) Equal(u *VaultList) bool {
	if len(v.Vaults) != len(u.Vaults) {
		return false
	}
	for i := range v.Vaults {
		if !(v.Vaults[i] == u.Vaults[i]) {
			return false
		}
	}

	return true
}

func (v *Version) Equal(u *Version) bool {
	if !(v.Major == u.Major) {
		return false
	}
	if !(v.Minor == u.Minor) {
		return false
	}
	if !(v.Revision == u.Revision) {
		return false
	}
	if !(v.Commit == u.Commit) {
		return false
	}

	return true
}

var fieldNames_Adi = []string{
	1: "Url",
	2: "Pages",
}

func (v *Adi) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.Url == nil) {
		writer.WriteUrl(1, v.Url)
	}
	if !(len(v.Pages) == 0) {
		for _, v := range v.Pages {
			writer.WriteValue(2, v.MarshalBinary)
		}
	}

	_, _, err := writer.Reset(fieldNames_Adi)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Adi) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Url is missing")
	} else if v.Url == nil {
		errs = append(errs, "field Url is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_KeyInfo = []string{
	1: "Type",
	2: "Derivation",
	3: "WalletId",
}

func (v *KeyInfo) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.Type == 0) {
		writer.WriteEnum(1, v.Type)
	}
	if !(len(v.Derivation) == 0) {
		writer.WriteString(2, v.Derivation)
	}
	if !(v.WalletId == nil) {
		writer.WriteUrl(3, v.WalletId)
	}

	_, _, err := writer.Reset(fieldNames_KeyInfo)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *KeyInfo) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Type is missing")
	} else if v.Type == 0 {
		errs = append(errs, "field Type is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_KeyLabels = []string{
	1: "Lite",
	2: "Hash",
	3: "Names",
}

func (v *KeyLabels) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(len(v.Lite) == 0) {
		writer.WriteString(1, v.Lite)
	}
	if !(len(v.Hash) == 0) {
		writer.WriteBytes(2, v.Hash)
	}
	if !(len(v.Names) == 0) {
		for _, v := range v.Names {
			writer.WriteString(3, v)
		}
	}

	_, _, err := writer.Reset(fieldNames_KeyLabels)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *KeyLabels) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Lite is missing")
	} else if len(v.Lite) == 0 {
		errs = append(errs, "field Lite is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Hash is missing")
	} else if len(v.Hash) == 0 {
		errs = append(errs, "field Hash is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field Names is missing")
	} else if len(v.Names) == 0 {
		errs = append(errs, "field Names is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_KeyName = []string{
	1: "Name",
	2: "PublicKey",
}

func (v *KeyName) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(len(v.Name) == 0) {
		writer.WriteString(1, v.Name)
	}
	if !(len(v.PublicKey) == 0) {
		writer.WriteBytes(2, v.PublicKey)
	}

	_, _, err := writer.Reset(fieldNames_KeyName)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *KeyName) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Name is missing")
	} else if len(v.Name) == 0 {
		errs = append(errs, "field Name is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field PublicKey is missing")
	} else if len(v.PublicKey) == 0 {
		errs = append(errs, "field PublicKey is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Page = []string{
	1: "Url",
	2: "KeyNames",
}

func (v *Page) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.Url == nil) {
		writer.WriteUrl(1, v.Url)
	}
	if !(len(v.KeyNames) == 0) {
		for _, v := range v.KeyNames {
			writer.WriteString(2, v)
		}
	}

	_, _, err := writer.Reset(fieldNames_Page)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Page) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Url is missing")
	} else if v.Url == nil {
		errs = append(errs, "field Url is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field KeyNames is missing")
	} else if len(v.KeyNames) == 0 {
		errs = append(errs, "field KeyNames is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_VaultInfo = []string{
	1: "Name",
	2: "FilePath",
	3: "OnePasswordRef",
}

func (v *VaultInfo) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(len(v.Name) == 0) {
		writer.WriteString(1, v.Name)
	}
	if !(len(v.FilePath) == 0) {
		writer.WriteString(2, v.FilePath)
	}
	if !(len(v.OnePasswordRef) == 0) {
		writer.WriteString(3, v.OnePasswordRef)
	}

	_, _, err := writer.Reset(fieldNames_VaultInfo)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *VaultInfo) IsValid() error {
	var errs []string

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_VaultList = []string{
	1: "Vaults",
}

func (v *VaultList) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(len(v.Vaults) == 0) {
		for _, v := range v.Vaults {
			writer.WriteString(1, v)
		}
	}

	_, _, err := writer.Reset(fieldNames_VaultList)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *VaultList) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Vaults is missing")
	} else if len(v.Vaults) == 0 {
		errs = append(errs, "field Vaults is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

func (v *Adi) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Adi) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUrl(1); ok {
		v.Url = x
	}
	for {
		if x := new(Page); reader.ReadValue(2, x.UnmarshalBinaryFrom) {
			v.Pages = append(v.Pages, *x)
		} else {
			break
		}
	}

	seen, err := reader.Reset(fieldNames_Adi)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *KeyInfo) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *KeyInfo) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x := new(protocol.SignatureType); reader.ReadEnum(1, x) {
		v.Type = *x
	}
	if x, ok := reader.ReadString(2); ok {
		v.Derivation = x
	}
	if x, ok := reader.ReadUrl(3); ok {
		v.WalletId = x
	}

	seen, err := reader.Reset(fieldNames_KeyInfo)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *KeyLabels) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *KeyLabels) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadString(1); ok {
		v.Lite = x
	}
	if x, ok := reader.ReadBytes(2); ok {
		v.Hash = x
	}
	for {
		if x, ok := reader.ReadString(3); ok {
			v.Names = append(v.Names, x)
		} else {
			break
		}
	}

	seen, err := reader.Reset(fieldNames_KeyLabels)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *KeyName) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *KeyName) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadString(1); ok {
		v.Name = x
	}
	if x, ok := reader.ReadBytes(2); ok {
		v.PublicKey = x
	}

	seen, err := reader.Reset(fieldNames_KeyName)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Page) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Page) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUrl(1); ok {
		v.Url = x
	}
	for {
		if x, ok := reader.ReadString(2); ok {
			v.KeyNames = append(v.KeyNames, x)
		} else {
			break
		}
	}

	seen, err := reader.Reset(fieldNames_Page)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *VaultInfo) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *VaultInfo) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadString(1); ok {
		v.Name = x
	}
	if x, ok := reader.ReadString(2); ok {
		v.FilePath = x
	}
	if x, ok := reader.ReadString(3); ok {
		v.OnePasswordRef = x
	}

	seen, err := reader.Reset(fieldNames_VaultInfo)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *VaultList) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *VaultList) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	for {
		if x, ok := reader.ReadString(1); ok {
			v.Vaults = append(v.Vaults, x)
		} else {
			break
		}
	}

	seen, err := reader.Reset(fieldNames_VaultList)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func init() {

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("url", "string"),
		encoding.NewTypeField("pages", "Page[]"),
	}, "Adi", "adi")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("walletId", "string"),
		encoding.NewTypeField("type", "string"),
		encoding.NewTypeField("count", "uint64"),
	}, "DerivationCount", "derivationCount")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("privateKey", "bytes"),
		encoding.NewTypeField("publicKey", "bytes"),
		encoding.NewTypeField("keyInfo", "KeyInfo"),
		encoding.NewTypeField("lastUsedOn", "uint64"),
		encoding.NewTypeField("labels", "KeyLabels"),
		encoding.NewTypeField("pages", "string[]"),
	}, "Key", "key")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("type", "string"),
		encoding.NewTypeField("derivation", "string"),
		encoding.NewTypeField("walletId", "string"),
	}, "KeyInfo", "keyInfo")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("lite", "string"),
		encoding.NewTypeField("hash", "bytes"),
		encoding.NewTypeField("names", "string[]"),
	}, "KeyLabels", "keyLabels")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("name", "string"),
		encoding.NewTypeField("publicKey", "bytes"),
	}, "KeyName", "keyName")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("liteName", "string"),
		encoding.NewTypeField("keyName", "string"),
	}, "LiteLabel", "liteLabel")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("url", "string"),
		encoding.NewTypeField("keyNames", "string[]"),
	}, "Page", "page")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("mnemonic", "string"),
		encoding.NewTypeField("seed", "bytes"),
	}, "SeedInfo", "seedInfo")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("backupDate", "string"),
		encoding.NewTypeField("version", "Version"),
		encoding.NewTypeField("seedInfo", "SeedInfo"),
		encoding.NewTypeField("derivationCounters", "DerivationCount[]"),
		encoding.NewTypeField("keys", "Key[]"),
		encoding.NewTypeField("keyNames", "KeyName[]"),
		encoding.NewTypeField("liteLabels", "LiteLabel[]"),
		encoding.NewTypeField("adis", "Adi[]"),
	}, "Vault", "vault")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("name", "string"),
		encoding.NewTypeField("filePath", "string"),
		encoding.NewTypeField("onePasswordRef", "string"),
	}, "VaultInfo", "vaultInfo")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("vaults", "string[]"),
	}, "VaultList", "vaultList")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("major", "uint64"),
		encoding.NewTypeField("minor", "uint64"),
		encoding.NewTypeField("revision", "uint64"),
		encoding.NewTypeField("commit", "uint64"),
	}, "Version", "version")

}

func (v *Adi) MarshalJSON() ([]byte, error) {
	u := struct {
		Url       *url.URL                `json:"url,omitempty"`
		Pages     encoding.JsonList[Page] `json:"pages,omitempty"`
		ExtraData *string                 `json:"$epilogue,omitempty"`
	}{}
	if !(v.Url == nil) {
		u.Url = v.Url
	}
	if !(len(v.Pages) == 0) {
		u.Pages = v.Pages
	}
	u.ExtraData = encoding.BytesToJSON(v.extraData)
	return json.Marshal(&u)
}

func (v *Key) MarshalJSON() ([]byte, error) {
	u := struct {
		PrivateKey *string                     `json:"privateKey,omitempty"`
		PublicKey  *string                     `json:"publicKey,omitempty"`
		KeyInfo    KeyInfo                     `json:"keyInfo,omitempty"`
		LastUsedOn uint64                      `json:"lastUsedOn,omitempty"`
		Labels     *KeyLabels                  `json:"labels,omitempty"`
		Pages      encoding.JsonList[*url.URL] `json:"pages,omitempty"`
	}{}
	if !(len(v.PrivateKey) == 0) {
		u.PrivateKey = encoding.BytesToJSON(v.PrivateKey)
	}
	if !(len(v.PublicKey) == 0) {
		u.PublicKey = encoding.BytesToJSON(v.PublicKey)
	}
	if !((v.KeyInfo).Equal(new(KeyInfo))) {
		u.KeyInfo = v.KeyInfo
	}
	if !(v.LastUsedOn == 0) {
		u.LastUsedOn = v.LastUsedOn
	}
	if !(v.Labels == nil) {
		u.Labels = v.Labels
	}
	if !(len(v.Pages) == 0) {
		u.Pages = v.Pages
	}
	return json.Marshal(&u)
}

func (v *KeyLabels) MarshalJSON() ([]byte, error) {
	u := struct {
		Lite      string                    `json:"lite,omitempty"`
		Hash      *string                   `json:"hash,omitempty"`
		Names     encoding.JsonList[string] `json:"names,omitempty"`
		ExtraData *string                   `json:"$epilogue,omitempty"`
	}{}
	if !(len(v.Lite) == 0) {
		u.Lite = v.Lite
	}
	if !(len(v.Hash) == 0) {
		u.Hash = encoding.BytesToJSON(v.Hash)
	}
	if !(len(v.Names) == 0) {
		u.Names = v.Names
	}
	u.ExtraData = encoding.BytesToJSON(v.extraData)
	return json.Marshal(&u)
}

func (v *KeyName) MarshalJSON() ([]byte, error) {
	u := struct {
		Name      string  `json:"name,omitempty"`
		PublicKey *string `json:"publicKey,omitempty"`
		ExtraData *string `json:"$epilogue,omitempty"`
	}{}
	if !(len(v.Name) == 0) {
		u.Name = v.Name
	}
	if !(len(v.PublicKey) == 0) {
		u.PublicKey = encoding.BytesToJSON(v.PublicKey)
	}
	u.ExtraData = encoding.BytesToJSON(v.extraData)
	return json.Marshal(&u)
}

func (v *Page) MarshalJSON() ([]byte, error) {
	u := struct {
		Url       *url.URL                  `json:"url,omitempty"`
		KeyNames  encoding.JsonList[string] `json:"keyNames,omitempty"`
		ExtraData *string                   `json:"$epilogue,omitempty"`
	}{}
	if !(v.Url == nil) {
		u.Url = v.Url
	}
	if !(len(v.KeyNames) == 0) {
		u.KeyNames = v.KeyNames
	}
	u.ExtraData = encoding.BytesToJSON(v.extraData)
	return json.Marshal(&u)
}

func (v *SeedInfo) MarshalJSON() ([]byte, error) {
	u := struct {
		Mnemonic string  `json:"mnemonic,omitempty"`
		Seed     *string `json:"seed,omitempty"`
	}{}
	if !(len(v.Mnemonic) == 0) {
		u.Mnemonic = v.Mnemonic
	}
	if !(len(v.Seed) == 0) {
		u.Seed = encoding.BytesToJSON(v.Seed)
	}
	return json.Marshal(&u)
}

func (v *Vault) MarshalJSON() ([]byte, error) {
	u := struct {
		BackupDate         time.Time                          `json:"backupDate,omitempty"`
		Version            Version                            `json:"version,omitempty"`
		SeedInfo           SeedInfo                           `json:"seedInfo,omitempty"`
		DerivationCounters encoding.JsonList[DerivationCount] `json:"derivationCounters,omitempty"`
		Keys               encoding.JsonList[Key]             `json:"keys,omitempty"`
		KeyNames           encoding.JsonList[KeyName]         `json:"keyNames,omitempty"`
		LiteLabels         encoding.JsonList[LiteLabel]       `json:"liteLabels,omitempty"`
		Adis               encoding.JsonList[Adi]             `json:"adis,omitempty"`
	}{}
	if !(v.BackupDate == (time.Time{})) {
		u.BackupDate = v.BackupDate
	}
	if !((v.Version).Equal(new(Version))) {
		u.Version = v.Version
	}
	if !((v.SeedInfo).Equal(new(SeedInfo))) {
		u.SeedInfo = v.SeedInfo
	}
	if !(len(v.DerivationCounters) == 0) {
		u.DerivationCounters = v.DerivationCounters
	}
	if !(len(v.Keys) == 0) {
		u.Keys = v.Keys
	}
	if !(len(v.KeyNames) == 0) {
		u.KeyNames = v.KeyNames
	}
	if !(len(v.LiteLabels) == 0) {
		u.LiteLabels = v.LiteLabels
	}
	if !(len(v.Adis) == 0) {
		u.Adis = v.Adis
	}
	return json.Marshal(&u)
}

func (v *VaultList) MarshalJSON() ([]byte, error) {
	u := struct {
		Vaults    encoding.JsonList[string] `json:"vaults,omitempty"`
		ExtraData *string                   `json:"$epilogue,omitempty"`
	}{}
	if !(len(v.Vaults) == 0) {
		u.Vaults = v.Vaults
	}
	u.ExtraData = encoding.BytesToJSON(v.extraData)
	return json.Marshal(&u)
}

func (v *Adi) UnmarshalJSON(data []byte) error {
	u := struct {
		Url       *url.URL                `json:"url,omitempty"`
		Pages     encoding.JsonList[Page] `json:"pages,omitempty"`
		ExtraData *string                 `json:"$epilogue,omitempty"`
	}{}
	u.Url = v.Url
	u.Pages = v.Pages
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Url = u.Url
	v.Pages = u.Pages
	v.extraData, err = encoding.BytesFromJSON(u.ExtraData)
	if err != nil {
		return err
	}
	return nil
}

func (v *Key) UnmarshalJSON(data []byte) error {
	u := struct {
		PrivateKey *string                     `json:"privateKey,omitempty"`
		PublicKey  *string                     `json:"publicKey,omitempty"`
		KeyInfo    KeyInfo                     `json:"keyInfo,omitempty"`
		LastUsedOn uint64                      `json:"lastUsedOn,omitempty"`
		Labels     *KeyLabels                  `json:"labels,omitempty"`
		Pages      encoding.JsonList[*url.URL] `json:"pages,omitempty"`
	}{}
	u.PrivateKey = encoding.BytesToJSON(v.PrivateKey)
	u.PublicKey = encoding.BytesToJSON(v.PublicKey)
	u.KeyInfo = v.KeyInfo
	u.LastUsedOn = v.LastUsedOn
	u.Labels = v.Labels
	u.Pages = v.Pages
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if x, err := encoding.BytesFromJSON(u.PrivateKey); err != nil {
		return fmt.Errorf("error decoding PrivateKey: %w", err)
	} else {
		v.PrivateKey = x
	}
	if x, err := encoding.BytesFromJSON(u.PublicKey); err != nil {
		return fmt.Errorf("error decoding PublicKey: %w", err)
	} else {
		v.PublicKey = x
	}
	v.KeyInfo = u.KeyInfo
	v.LastUsedOn = u.LastUsedOn
	v.Labels = u.Labels
	v.Pages = u.Pages
	return nil
}

func (v *KeyLabels) UnmarshalJSON(data []byte) error {
	u := struct {
		Lite      string                    `json:"lite,omitempty"`
		Hash      *string                   `json:"hash,omitempty"`
		Names     encoding.JsonList[string] `json:"names,omitempty"`
		ExtraData *string                   `json:"$epilogue,omitempty"`
	}{}
	u.Lite = v.Lite
	u.Hash = encoding.BytesToJSON(v.Hash)
	u.Names = v.Names
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Lite = u.Lite
	if x, err := encoding.BytesFromJSON(u.Hash); err != nil {
		return fmt.Errorf("error decoding Hash: %w", err)
	} else {
		v.Hash = x
	}
	v.Names = u.Names
	v.extraData, err = encoding.BytesFromJSON(u.ExtraData)
	if err != nil {
		return err
	}
	return nil
}

func (v *KeyName) UnmarshalJSON(data []byte) error {
	u := struct {
		Name      string  `json:"name,omitempty"`
		PublicKey *string `json:"publicKey,omitempty"`
		ExtraData *string `json:"$epilogue,omitempty"`
	}{}
	u.Name = v.Name
	u.PublicKey = encoding.BytesToJSON(v.PublicKey)
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Name = u.Name
	if x, err := encoding.BytesFromJSON(u.PublicKey); err != nil {
		return fmt.Errorf("error decoding PublicKey: %w", err)
	} else {
		v.PublicKey = x
	}
	v.extraData, err = encoding.BytesFromJSON(u.ExtraData)
	if err != nil {
		return err
	}
	return nil
}

func (v *Page) UnmarshalJSON(data []byte) error {
	u := struct {
		Url       *url.URL                  `json:"url,omitempty"`
		KeyNames  encoding.JsonList[string] `json:"keyNames,omitempty"`
		ExtraData *string                   `json:"$epilogue,omitempty"`
	}{}
	u.Url = v.Url
	u.KeyNames = v.KeyNames
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Url = u.Url
	v.KeyNames = u.KeyNames
	v.extraData, err = encoding.BytesFromJSON(u.ExtraData)
	if err != nil {
		return err
	}
	return nil
}

func (v *SeedInfo) UnmarshalJSON(data []byte) error {
	u := struct {
		Mnemonic string  `json:"mnemonic,omitempty"`
		Seed     *string `json:"seed,omitempty"`
	}{}
	u.Mnemonic = v.Mnemonic
	u.Seed = encoding.BytesToJSON(v.Seed)
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Mnemonic = u.Mnemonic
	if x, err := encoding.BytesFromJSON(u.Seed); err != nil {
		return fmt.Errorf("error decoding Seed: %w", err)
	} else {
		v.Seed = x
	}
	return nil
}

func (v *Vault) UnmarshalJSON(data []byte) error {
	u := struct {
		BackupDate         time.Time                          `json:"backupDate,omitempty"`
		Version            Version                            `json:"version,omitempty"`
		SeedInfo           SeedInfo                           `json:"seedInfo,omitempty"`
		DerivationCounters encoding.JsonList[DerivationCount] `json:"derivationCounters,omitempty"`
		Keys               encoding.JsonList[Key]             `json:"keys,omitempty"`
		KeyNames           encoding.JsonList[KeyName]         `json:"keyNames,omitempty"`
		LiteLabels         encoding.JsonList[LiteLabel]       `json:"liteLabels,omitempty"`
		Adis               encoding.JsonList[Adi]             `json:"adis,omitempty"`
	}{}
	u.BackupDate = v.BackupDate
	u.Version = v.Version
	u.SeedInfo = v.SeedInfo
	u.DerivationCounters = v.DerivationCounters
	u.Keys = v.Keys
	u.KeyNames = v.KeyNames
	u.LiteLabels = v.LiteLabels
	u.Adis = v.Adis
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.BackupDate = u.BackupDate
	v.Version = u.Version
	v.SeedInfo = u.SeedInfo
	v.DerivationCounters = u.DerivationCounters
	v.Keys = u.Keys
	v.KeyNames = u.KeyNames
	v.LiteLabels = u.LiteLabels
	v.Adis = u.Adis
	return nil
}

func (v *VaultList) UnmarshalJSON(data []byte) error {
	u := struct {
		Vaults    encoding.JsonList[string] `json:"vaults,omitempty"`
		ExtraData *string                   `json:"$epilogue,omitempty"`
	}{}
	u.Vaults = v.Vaults
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	v.Vaults = u.Vaults
	v.extraData, err = encoding.BytesFromJSON(u.ExtraData)
	if err != nil {
		return err
	}
	return nil
}
